searchData={"items":[{"type":"module","title":"DevWeb","doc":"","ref":"DevWeb.html"},{"type":"function","title":"DevWeb.live_component/0","doc":"","ref":"DevWeb.html#live_component/0"},{"type":"function","title":"DevWeb.live_view/0","doc":"","ref":"DevWeb.html#live_view/0"},{"type":"module","title":"LiveDebugger","doc":"Debugger for LiveView applications.","ref":"LiveDebugger.html"},{"type":"function","title":"LiveDebugger.start/2","doc":"","ref":"LiveDebugger.html#start/2"},{"type":"module","title":"LiveDebugger.CommonTypes","doc":"This module provides types used in the LiveDebugger application.","ref":"LiveDebugger.CommonTypes.html"},{"type":"type","title":"LiveDebugger.CommonTypes.channel_state/0","doc":"Type for state of a channel that hosts a LiveView.","ref":"LiveDebugger.CommonTypes.html#t:channel_state/0"},{"type":"type","title":"LiveDebugger.CommonTypes.cid/0","doc":"","ref":"LiveDebugger.CommonTypes.html#t:cid/0"},{"type":"module","title":"LiveDebugger.Components","doc":"This module provides reusable components for LiveDebugger.","ref":"LiveDebugger.Components.html"},{"type":"function","title":"LiveDebugger.Components.alert/1","doc":"Renders an alert\nRight now we have styles only for `danger` variant, but it'll change soon","ref":"LiveDebugger.Components.html#alert/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.alert/1","doc":"* `variant` (`:string`) (required) - Must be one of `\"danger\"`.\n* `class` (`:any`) - Additional classes to add to the alert. Defaults to `nil`.\n* `with_icon` (`:boolean`) - Whether to show an icon. Defaults to `false`.\n* `heading` (`:string`) - Heading for the alert. Defaults to `nil`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#alert/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.alert/1","doc":"* `inner_block` (required)","ref":"LiveDebugger.Components.html#alert/1-slots"},{"type":"function","title":"LiveDebugger.Components.badge/1","doc":"","ref":"LiveDebugger.Components.html#badge/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.badge/1","doc":"* `text` (`:string`) (required)\n* `icon` (`:string`) (required)","ref":"LiveDebugger.Components.html#badge/1-attributes"},{"type":"function","title":"LiveDebugger.Components.button/1","doc":"Renders a button.","ref":"LiveDebugger.Components.html#button/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.button/1","doc":"* `variant` (`:string`) - Defaults to `\"primary\"`.\n* `size` (`:string`) - Defaults to `\"md\"`.\n* `class` (`:any`) - Additional classes to add to the button. Defaults to `nil`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#button/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.button/1","doc":"* `inner_block` (required)","ref":"LiveDebugger.Components.html#button/1-slots"},{"type":"function","title":"LiveDebugger.Components.checkbox/1","doc":"Renders a checkbox.","ref":"LiveDebugger.Components.html#checkbox/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.checkbox/1","doc":"* `field` (`Phoenix.HTML.FormField`) (required)\n* `label` (`:string`) - Defaults to `nil`.\n* `wrapper_class` (`:any`) - Defaults to `nil`.\n* `input_class` (`:any`) - Defaults to `nil`.\n* `label_class` (`:any`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"type\"]`.","ref":"LiveDebugger.Components.html#checkbox/1-attributes"},{"type":"function","title":"LiveDebugger.Components.collapsible/1","doc":"Collapsible element that can be toggled open and closed.\nIt uses the `details` and `summary` HTML elements.\nIf you add `hide-on-open` class to element it will be hidden when collapsible is opened.","ref":"LiveDebugger.Components.html#collapsible/1"},{"type":"function","title":"Examples - LiveDebugger.Components.collapsible/1","doc":"<.collapsible id=\"collapsible\" open={true}>\n      <:label>\n         Collapsible  Info when closed  \n      </:label>\n       Content \n    </.collapsible>","ref":"LiveDebugger.Components.html#collapsible/1-examples"},{"type":"function","title":"Attributes - LiveDebugger.Components.collapsible/1","doc":"* `id` (`:string`) (required)\n* `class` (`:any`) - CSS class for parent container. Defaults to `nil`.\n* `label_class` (`:any`) - CSS class for the label. Defaults to `nil`.\n* `chevron_class` (`:any`) - CSS class for the chevron icon. Defaults to `nil`.\n* `open` (`:boolean`) - Whether the collapsible is open by default. Defaults to `false`.\n* `icon` (`:string`) - Icon for chevron. It will be rotated 90 degrees when the collapsible is open. Defaults to `\"icon-chevron-right\"`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#collapsible/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.collapsible/1","doc":"* `label` (required)\n* `inner_block` (required)","ref":"LiveDebugger.Components.html#collapsible/1-slots"},{"type":"function","title":"LiveDebugger.Components.flash/1","doc":"Renders flash notices.","ref":"LiveDebugger.Components.html#flash/1"},{"type":"function","title":"Examples - LiveDebugger.Components.flash/1","doc":"<.flash flash={@flash} />\n    <.flash phx-mounted={show(\"#flash\")}>Welcome Back!</.flash>","ref":"LiveDebugger.Components.html#flash/1-examples"},{"type":"function","title":"Attributes - LiveDebugger.Components.flash/1","doc":"* `id` (`:string`) - the optional id of flash container.\n* `flash` (`:map`) - the map of flash messages to display. Defaults to `%{}`.\n* Global attributes are accepted. the arbitrary HTML attributes to add to the flash container.","ref":"LiveDebugger.Components.html#flash/1-attributes"},{"type":"function","title":"LiveDebugger.Components.fullscreen/1","doc":"Renders a fullscreen using Fullscreen hook.\nIt can be opened and via browser \"open\" event (by default) with JS.dispatch or via server event (check example in fullscreen button).\n\nYou can use `fullscreen_button` to open this fullscreen.\nYou can close the fullscreen using X button or by pressing ESC key.","ref":"LiveDebugger.Components.html#fullscreen/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.fullscreen/1","doc":"* `id` (`:string`) (required)\n* `title` (`:string`) - Title of the fullscreen. Defaults to `\"\"`.\n* `class` (`:any`) - Additional classes to be added to the fullscreen element. Defaults to `nil`.","ref":"LiveDebugger.Components.html#fullscreen/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.fullscreen/1","doc":"* `inner_block` (required)","ref":"LiveDebugger.Components.html#fullscreen/1-slots"},{"type":"function","title":"LiveDebugger.Components.fullscreen_button/1","doc":"Renders a button which will show a fullscreen when clicked.\nYou can override `phx-click` value, but remember to push correct event at the end of `handle_event` function.","ref":"LiveDebugger.Components.html#fullscreen_button/1"},{"type":"function","title":"Examples - LiveDebugger.Components.fullscreen_button/1","doc":"<.fullscreen_button\n      id=\"my-fullscreen\"\n      phx-click=\"open-fullscreen\"\n      icon=\"icon-expand\"\n    />\n\n    @impl true\n    def handle_event(\"open-fullscreen\", _, socket) do\n      trace_id = String.to_integer(string_id)\n\n      socket\n      |> push_event(\"my-fullscreen-open\", %{})\n      |> noreply()\n    end","ref":"LiveDebugger.Components.html#fullscreen_button/1-examples"},{"type":"function","title":"Attributes - LiveDebugger.Components.fullscreen_button/1","doc":"* `id` (`:string`) (required) - Same as `id` of the fullscreen.\n* `class` (`:any`) - Additional classes to be added to the button. Defaults to `nil`.\n* `icon` (`:string`) - Icon to be displayed as a button. Defaults to `\"icon-expand\"`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#fullscreen_button/1-attributes"},{"type":"function","title":"LiveDebugger.Components.h1/1","doc":"Typography component to render headings.","ref":"LiveDebugger.Components.html#h1/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.h1/1","doc":"* `class` (`:any`) - Additional classes to add to the heading. Defaults to `nil`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#h1/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.h1/1","doc":"* `inner_block` (required)","ref":"LiveDebugger.Components.html#h1/1-slots"},{"type":"function","title":"LiveDebugger.Components.icon/1","doc":"Renders an icon.\nNot all icons are available. If you want to use an icon check if it exists in the `assets/icons` folder.\n`name` must start with `icon-`","ref":"LiveDebugger.Components.html#icon/1"},{"type":"function","title":"Examples - LiveDebugger.Components.icon/1","doc":"<.icon name=\"icon-play\" />","ref":"LiveDebugger.Components.html#icon/1-examples"},{"type":"function","title":"Attributes - LiveDebugger.Components.icon/1","doc":"* `name` (`:string`) (required) - The name of the icon. Must start with `icon-`.\n* `class` (`:any`) - Additional classes to add to the icon. Defaults to `nil`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#icon/1-attributes"},{"type":"function","title":"LiveDebugger.Components.icon_button/1","doc":"Renders a button with an icon in it.","ref":"LiveDebugger.Components.html#icon_button/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.icon_button/1","doc":"* `icon` (`:string`) (required) - Icon to be displayed as a button.\n* `size` (`:string`) - Size of the button. Defaults to `\"md\"`.\n* `variant` (`:string`) - Variant of the button. Defaults to `\"primary\"`.\n* `class` (`:any`) - Additional classes to add to the button. Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"id\"]`.","ref":"LiveDebugger.Components.html#icon_button/1-attributes"},{"type":"function","title":"LiveDebugger.Components.list/1","doc":"","ref":"LiveDebugger.Components.html#list/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.list/1","doc":"* `elements` (`:list`) (required) - Elements that will be displayed in the list's `item` slot.\n* `class` (`:any`) - Additional classes. Defaults to `nil`.\n* `item_class` (`:any`) - Additional classes for each item. Defaults to `nil`.","ref":"LiveDebugger.Components.html#list/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.list/1","doc":"* `item` (required)","ref":"LiveDebugger.Components.html#list/1-slots"},{"type":"function","title":"LiveDebugger.Components.nav_icon/1","doc":"","ref":"LiveDebugger.Components.html#nav_icon/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.nav_icon/1","doc":"* `icon` (`:string`) (required) - Icon to be displayed.\n* `class` (`:any`) - Additional classes to add to the nav icon. Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"id\"]`.","ref":"LiveDebugger.Components.html#nav_icon/1-attributes"},{"type":"function","title":"LiveDebugger.Components.navbar/1","doc":"Renders navbar with possible link to return to the main page.","ref":"LiveDebugger.Components.html#navbar/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.navbar/1","doc":"* `return_link?` (`:boolean`) (required) - Whether to show a link to return to the main page.","ref":"LiveDebugger.Components.html#navbar/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.navbar/1","doc":"* `inner_block`","ref":"LiveDebugger.Components.html#navbar/1-slots"},{"type":"function","title":"LiveDebugger.Components.report_issue/1","doc":"","ref":"LiveDebugger.Components.html#report_issue/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.report_issue/1","doc":"* `class` (`:any`) - Defaults to `nil`.\n* `text` (`:string`) - Defaults to `\"See any issues?\"`.","ref":"LiveDebugger.Components.html#report_issue/1-attributes"},{"type":"function","title":"LiveDebugger.Components.section/1","doc":"","ref":"LiveDebugger.Components.html#section/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.section/1","doc":"* `id` (`:string`) (required)\n* `title` (`:string`) (required)\n* `class` (`:any`) - Defaults to `nil`.\n* `inner_class` (`:any`) - Defaults to `nil`.","ref":"LiveDebugger.Components.html#section/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.section/1","doc":"* `right_panel`\n* `inner_block`","ref":"LiveDebugger.Components.html#section/1-slots"},{"type":"function","title":"LiveDebugger.Components.show_collapsible_assign/1","doc":"Used to add Hook to element based on condition.","ref":"LiveDebugger.Components.html#show_collapsible_assign/1"},{"type":"function","title":"LiveDebugger.Components.spinner/1","doc":"","ref":"LiveDebugger.Components.html#spinner/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.spinner/1","doc":"* `class` (`:any`) - CSS class. Defaults to `nil`.\n* `size` (`:string`) - Size of the spinner. Defaults to `\"md\"`.\n* `show` (`:boolean`) - show or hide spinner. Defaults to `true`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#spinner/1-attributes"},{"type":"function","title":"LiveDebugger.Components.toggle_switch/1","doc":"Renders a switch component.\n\nBased on [Tailwind CSS Toggle - Flowbite](https://flowbite.com/docs/forms/toggle)","ref":"LiveDebugger.Components.html#toggle_switch/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.toggle_switch/1","doc":"* `checked` (`:boolean`) - Whether the switch is checked. Defaults to `false`.\n* `label` (`:string`) - Label for the switch. Defaults to `\"\"`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#toggle_switch/1-attributes"},{"type":"function","title":"LiveDebugger.Components.tooltip/1","doc":"Renders a tooltip using Tooltip hook.","ref":"LiveDebugger.Components.html#tooltip/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.tooltip/1","doc":"* `id` (`:string`) (required)\n* `content` (`:string`) - Defaults to `nil`.\n* `position` (`:string`) - Defaults to `\"top\"`.\n* Global attributes are accepted.","ref":"LiveDebugger.Components.html#tooltip/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.Components.tooltip/1","doc":"* `inner_block` (required)","ref":"LiveDebugger.Components.html#tooltip/1-slots"},{"type":"module","title":"LiveDebugger.Components.Config","doc":"Renders the LiveDebugger config meta tag and the browser features script.\nIt is meant to be injected to the debugged application layout.","ref":"LiveDebugger.Components.Config.html"},{"type":"function","title":"LiveDebugger.Components.Config.live_debugger_tags/1","doc":"","ref":"LiveDebugger.Components.Config.html#live_debugger_tags/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Config.live_debugger_tags/1","doc":"* `url` (`:string`) (required)\n* `assets_url` (`:string`) (required)\n* `browser_features?` (`:boolean`) - Defaults to `true`.\n* `debug_button?` (`:boolean`) - Defaults to `true`.\n* `highlighting?` (`:boolean`) - Defaults to `true`.","ref":"LiveDebugger.Components.Config.html#live_debugger_tags/1-attributes"},{"type":"module","title":"LiveDebugger.Components.ElixirDisplay","doc":"This module provides a component to display a tree of terms.\nCheck LiveDebugger.Utils.TermParser.","ref":"LiveDebugger.Components.ElixirDisplay.html"},{"type":"function","title":"LiveDebugger.Components.ElixirDisplay.term/1","doc":"Returns a tree of terms.","ref":"LiveDebugger.Components.ElixirDisplay.html#term/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.ElixirDisplay.term/1","doc":"* `id` (`:string`) (required)\n* `node` (`:any`) (required)\n* `level` (`:integer`) (required)","ref":"LiveDebugger.Components.ElixirDisplay.html#term/1-attributes"},{"type":"module","title":"LiveDebugger.Components.Links","doc":"Adds styling for links.","ref":"LiveDebugger.Components.Links.html"},{"type":"function","title":"LiveDebugger.Components.Links.live_view/1","doc":"","ref":"LiveDebugger.Components.Links.html#live_view/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Links.live_view/1","doc":"* `lv_process` (`LiveDebugger.Structs.LvProcess`) (required)\n* `id` (`:string`) (required)\n* `icon` (`:any`) - Icon to add before module name. If `nil` no icon added. Defaults to `nil`.","ref":"LiveDebugger.Components.Links.html#live_view/1-attributes"},{"type":"module","title":"LiveDebugger.Components.Traces","doc":"UI components for the TracesLive module.","ref":"LiveDebugger.Components.Traces.html"},{"type":"function","title":"LiveDebugger.Components.Traces.clear_button/1","doc":"","ref":"LiveDebugger.Components.Traces.html#clear_button/1"},{"type":"function","title":"LiveDebugger.Components.Traces.refresh_button/1","doc":"","ref":"LiveDebugger.Components.Traces.html#refresh_button/1"},{"type":"function","title":"LiveDebugger.Components.Traces.separator/1","doc":"","ref":"LiveDebugger.Components.Traces.html#separator/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Traces.separator/1","doc":"* `id` (`:string`) (required)","ref":"LiveDebugger.Components.Traces.html#separator/1-attributes"},{"type":"function","title":"LiveDebugger.Components.Traces.short_trace_content/1","doc":"","ref":"LiveDebugger.Components.Traces.html#short_trace_content/1"},{"type":"function","title":"LiveDebugger.Components.Traces.toggle_tracing_button/1","doc":"","ref":"LiveDebugger.Components.Traces.html#toggle_tracing_button/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Traces.toggle_tracing_button/1","doc":"* `tracing_started?` (`:boolean`) (required)","ref":"LiveDebugger.Components.Traces.html#toggle_tracing_button/1-attributes"},{"type":"function","title":"LiveDebugger.Components.Traces.trace/1","doc":"","ref":"LiveDebugger.Components.Traces.html#trace/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Traces.trace/1","doc":"* `id` (`:string`) (required)\n* `wrapped_trace` (`:map`) (required) - The Trace to render.","ref":"LiveDebugger.Components.Traces.html#trace/1-attributes"},{"type":"function","title":"LiveDebugger.Components.Traces.trace_fullscreen/1","doc":"","ref":"LiveDebugger.Components.Traces.html#trace_fullscreen/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Traces.trace_fullscreen/1","doc":"* `id` (`:string`) (required)\n* `trace` (`:map`) - Defaults to `nil`.","ref":"LiveDebugger.Components.Traces.html#trace_fullscreen/1-attributes"},{"type":"module","title":"LiveDebugger.Components.Tree","doc":"Tree component which show nested tree of live view and live components.","ref":"LiveDebugger.Components.Tree.html"},{"type":"function","title":"LiveDebugger.Components.Tree.max_opened_node_level/2","doc":"Calculates the maximum level to be opened in the tree.","ref":"LiveDebugger.Components.Tree.html#max_opened_node_level/2"},{"type":"function","title":"LiveDebugger.Components.Tree.tree/1","doc":"Tree component which show nested tree of live view and live components.\nYou need to pass TreeNode struct to render the tree.\nThis component emits `select_node` event with `node_id` param when a node is clicked. `node_id` is parsed.\nTo calculate `max_opened_node_level` it uses `max_nesting_level/2` function.","ref":"LiveDebugger.Components.Tree.html#tree/1"},{"type":"function","title":"Attributes - LiveDebugger.Components.Tree.tree/1","doc":"* `tree_node` (`:any`) (required) - The TreeNode struct to render.\n* `title` (`:string`) (required) - The title of the tree.\n* `selected_node_id` (`:string`) (required) - The id of the selected node.\n* `highlight?` (`:boolean`) - The highlight flag. Defaults to `false`.\n* `class` (`:string`) - CSS class. Defaults to `nil`.\n* `max_opened_node_level` (`:integer`) (required) - The maximum level of the tree to be opened.","ref":"LiveDebugger.Components.Tree.html#tree/1-attributes"},{"type":"module","title":"LiveDebugger.Endpoint","doc":"","ref":"LiveDebugger.Endpoint.html"},{"type":"function","title":"LiveDebugger.Endpoint.broadcast/3","doc":"","ref":"LiveDebugger.Endpoint.html#broadcast/3"},{"type":"function","title":"LiveDebugger.Endpoint.broadcast!/3","doc":"","ref":"LiveDebugger.Endpoint.html#broadcast!/3"},{"type":"function","title":"LiveDebugger.Endpoint.broadcast_from/4","doc":"","ref":"LiveDebugger.Endpoint.html#broadcast_from/4"},{"type":"function","title":"LiveDebugger.Endpoint.broadcast_from!/4","doc":"","ref":"LiveDebugger.Endpoint.html#broadcast_from!/4"},{"type":"function","title":"LiveDebugger.Endpoint.call/2","doc":"","ref":"LiveDebugger.Endpoint.html#call/2"},{"type":"function","title":"LiveDebugger.Endpoint.child_spec/1","doc":"Returns the child specification to start the endpoint\nunder a supervision tree.","ref":"LiveDebugger.Endpoint.html#child_spec/1"},{"type":"function","title":"LiveDebugger.Endpoint.config/2","doc":"Returns the endpoint configuration for `key`\n\nReturns `default` if the key does not exist.","ref":"LiveDebugger.Endpoint.html#config/2"},{"type":"function","title":"LiveDebugger.Endpoint.config_change/2","doc":"Reloads the configuration given the application environment changes.","ref":"LiveDebugger.Endpoint.html#config_change/2"},{"type":"function","title":"LiveDebugger.Endpoint.host/0","doc":"Returns the host for the given endpoint.","ref":"LiveDebugger.Endpoint.html#host/0"},{"type":"function","title":"LiveDebugger.Endpoint.init/1","doc":"","ref":"LiveDebugger.Endpoint.html#init/1"},{"type":"function","title":"LiveDebugger.Endpoint.local_broadcast/3","doc":"","ref":"LiveDebugger.Endpoint.html#local_broadcast/3"},{"type":"function","title":"LiveDebugger.Endpoint.local_broadcast_from/4","doc":"","ref":"LiveDebugger.Endpoint.html#local_broadcast_from/4"},{"type":"function","title":"LiveDebugger.Endpoint.path/1","doc":"Generates the path information when routing to this endpoint.","ref":"LiveDebugger.Endpoint.html#path/1"},{"type":"function","title":"LiveDebugger.Endpoint.script_name/0","doc":"Generates the script name.","ref":"LiveDebugger.Endpoint.html#script_name/0"},{"type":"function","title":"LiveDebugger.Endpoint.server_info/1","doc":"Returns the address and port that the server is running on","ref":"LiveDebugger.Endpoint.html#server_info/1"},{"type":"function","title":"LiveDebugger.Endpoint.start_link/1","doc":"Starts the endpoint supervision tree.\n\nAll other options are merged into the endpoint configuration.","ref":"LiveDebugger.Endpoint.html#start_link/1"},{"type":"function","title":"LiveDebugger.Endpoint.static_integrity/1","doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file\nin `priv/static`. Meant to be used for Subresource Integrity with CDNs.","ref":"LiveDebugger.Endpoint.html#static_integrity/1"},{"type":"function","title":"LiveDebugger.Endpoint.static_lookup/1","doc":"Returns a two item tuple with the first item being the `static_path`\nand the second item being the `static_integrity`.","ref":"LiveDebugger.Endpoint.html#static_lookup/1"},{"type":"function","title":"LiveDebugger.Endpoint.static_path/1","doc":"Generates a route to a static file in `priv/static`.","ref":"LiveDebugger.Endpoint.html#static_path/1"},{"type":"function","title":"LiveDebugger.Endpoint.static_url/0","doc":"Generates the static URL without any path information.\n\nIt uses the configuration under `:static_url` to generate\nsuch. It falls back to `:url` if `:static_url` is not set.","ref":"LiveDebugger.Endpoint.html#static_url/0"},{"type":"function","title":"LiveDebugger.Endpoint.struct_url/0","doc":"Generates the endpoint base URL but as a `URI` struct.\n\nIt uses the configuration under `:url` to generate such.\nUseful for manipulating the URL data and passing it to\nURL helpers.","ref":"LiveDebugger.Endpoint.html#struct_url/0"},{"type":"function","title":"LiveDebugger.Endpoint.subscribe/2","doc":"","ref":"LiveDebugger.Endpoint.html#subscribe/2"},{"type":"function","title":"LiveDebugger.Endpoint.unsubscribe/1","doc":"","ref":"LiveDebugger.Endpoint.html#unsubscribe/1"},{"type":"function","title":"LiveDebugger.Endpoint.url/0","doc":"Generates the endpoint base URL without any path information.\n\nIt uses the configuration under `:url` to generate such.","ref":"LiveDebugger.Endpoint.html#url/0"},{"type":"module","title":"LiveDebugger.Env","doc":"Gives you a save option to check env in runtime","ref":"LiveDebugger.Env.html"},{"type":"function","title":"LiveDebugger.Env.dev?/0","doc":"","ref":"LiveDebugger.Env.html#dev?/0"},{"type":"function","title":"LiveDebugger.Env.test?/0","doc":"","ref":"LiveDebugger.Env.html#test?/0"},{"type":"function","title":"LiveDebugger.Env.unit_test?/0","doc":"","ref":"LiveDebugger.Env.html#unit_test?/0"},{"type":"module","title":"LiveDebugger.Feature","doc":"Feature flags for LiveDebugger.\nIf you create a new feature, create a new function here with defined rules for enabling it.","ref":"LiveDebugger.Feature.html"},{"type":"function","title":"LiveDebugger.Feature.enabled?/1","doc":"","ref":"LiveDebugger.Feature.html#enabled?/1"},{"type":"module","title":"LiveDebugger.Flash","doc":"Functionalities to make flash messages work inside LiveComponents\nSee: https://sevenseacat.net/posts/2023/flash-messages-in-phoenix-liveview-components/","ref":"LiveDebugger.Flash.html"},{"type":"function","title":"LiveDebugger.Flash.on_mount/4","doc":"Attaches hook to handle flash messages","ref":"LiveDebugger.Flash.html#on_mount/4"},{"type":"function","title":"LiveDebugger.Flash.push_flash/2","doc":"Extended Phoenix.LiveView.put_flash/3 which works inside nested LiveViews/LiveComponents.\nIf used in nested LiveView use root LiveView's pid.","ref":"LiveDebugger.Flash.html#push_flash/2"},{"type":"function","title":"LiveDebugger.Flash.push_flash/3","doc":"","ref":"LiveDebugger.Flash.html#push_flash/3"},{"type":"module","title":"LiveDebugger.GenServers.CallbackTracingServer","doc":"This gen_server is responsible for tracing callbacks and managing ETS tables.","ref":"LiveDebugger.GenServers.CallbackTracingServer.html"},{"type":"function","title":"LiveDebugger.GenServers.CallbackTracingServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"LiveDebugger.GenServers.CallbackTracingServer.html#child_spec/1"},{"type":"function","title":"LiveDebugger.GenServers.CallbackTracingServer.delete_table!/1","doc":"If table for given `pid` exists it deletes it from ETS.","ref":"LiveDebugger.GenServers.CallbackTracingServer.html#delete_table!/1"},{"type":"function","title":"LiveDebugger.GenServers.CallbackTracingServer.ping!/0","doc":"Checks if GenServer has been loaded","ref":"LiveDebugger.GenServers.CallbackTracingServer.html#ping!/0"},{"type":"function","title":"LiveDebugger.GenServers.CallbackTracingServer.table!/1","doc":"Returns ETS table reference.\nIt creates table if none is associated with given pid","ref":"LiveDebugger.GenServers.CallbackTracingServer.html#table!/1"},{"type":"type","title":"LiveDebugger.GenServers.CallbackTracingServer.table_refs/0","doc":"","ref":"LiveDebugger.GenServers.CallbackTracingServer.html#t:table_refs/0"},{"type":"module","title":"LiveDebugger.Layout","doc":"Inspiration was taken from Phoenix LiveDashboard\nhttps://github.com/phoenixframework/phoenix_live_dashboard/blob/main/lib/phoenix/live_dashboard/layout_view.ex\nhttps://github.com/phoenixframework/phoenix_live_dashboard/blob/main/lib/phoenix/live_dashboard/layouts/dash.html.heex","ref":"LiveDebugger.Layout.html"},{"type":"module","title":"LiveDebugger.LiveComponents.FiltersForm","doc":"Form for filtering traces by callback.\nIt sends `{:filters_updated, filters}` to the parent LiveView.","ref":"LiveDebugger.LiveComponents.FiltersForm.html"},{"type":"function","title":"LiveDebugger.LiveComponents.FiltersForm.assign_form/2","doc":"","ref":"LiveDebugger.LiveComponents.FiltersForm.html#assign_form/2"},{"type":"function","title":"LiveDebugger.LiveComponents.FiltersForm.get_callbacks/1","doc":"","ref":"LiveDebugger.LiveComponents.FiltersForm.html#get_callbacks/1"},{"type":"module","title":"LiveDebugger.LiveComponents.LiveDropdown","doc":"Dropdown component that can be used to display a dropdown menu written via LiveComponents.","ref":"LiveDebugger.LiveComponents.LiveDropdown.html"},{"type":"function","title":"LiveDebugger.LiveComponents.LiveDropdown.close/1","doc":"Closes the dropdown. You can use it when you want to close the dropdown from other component.","ref":"LiveDebugger.LiveComponents.LiveDropdown.html#close/1"},{"type":"function","title":"LiveDebugger.LiveComponents.LiveDropdown.handle_event/3","doc":"","ref":"LiveDebugger.LiveComponents.LiveDropdown.html#handle_event/3"},{"type":"function","title":"LiveDebugger.LiveComponents.LiveDropdown.render/1","doc":"","ref":"LiveDebugger.LiveComponents.LiveDropdown.html#render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveComponents.LiveDropdown.render/1","doc":"* `id` (`:string`) (required)\n* `open` (`:boolean`) (required)","ref":"LiveDebugger.LiveComponents.LiveDropdown.html#render/1-attributes"},{"type":"function","title":"Slots - LiveDebugger.LiveComponents.LiveDropdown.render/1","doc":"* `button` (required) - Accepts attributes:\n\n  * `class` (`:any`) - Additional classes to add to the button.\n  * `size` (`:string`) - Size of the button.Must be one of `\"sm\"`, or `\"md\"`.\n  * `variant` (`:string`) - Variant of the button.Must be one of `\"primary\"`, or `\"secondary\"`.\n* `inner_block` (required)","ref":"LiveDebugger.LiveComponents.LiveDropdown.html#render/1-slots"},{"type":"function","title":"LiveDebugger.LiveComponents.LiveDropdown.update/2","doc":"","ref":"LiveDebugger.LiveComponents.LiveDropdown.html#update/2"},{"type":"module","title":"LiveDebugger.LiveComponents.NestedLiveViewsLinks","doc":"List of links to LvProcesses nested inside `lv_process`","ref":"LiveDebugger.LiveComponents.NestedLiveViewsLinks.html"},{"type":"function","title":"LiveDebugger.LiveComponents.NestedLiveViewsLinks.render/1","doc":"","ref":"LiveDebugger.LiveComponents.NestedLiveViewsLinks.html#render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveComponents.NestedLiveViewsLinks.render/1","doc":"* `lv_process` (`LiveDebugger.Structs.LvProcess`) (required)","ref":"LiveDebugger.LiveComponents.NestedLiveViewsLinks.html#render/1-attributes"},{"type":"module","title":"LiveDebugger.LiveHelpers.Routes","doc":"Helper module to generate url routes for the LiveDebugger application.","ref":"LiveDebugger.LiveHelpers.Routes.html"},{"type":"function","title":"LiveDebugger.LiveHelpers.Routes.channel_dashboard/2","doc":"","ref":"LiveDebugger.LiveHelpers.Routes.html#channel_dashboard/2"},{"type":"function","title":"LiveDebugger.LiveHelpers.Routes.live_views_dashboard/0","doc":"","ref":"LiveDebugger.LiveHelpers.Routes.html#live_views_dashboard/0"},{"type":"module","title":"LiveDebugger.LiveHelpers.TracingHelper","doc":"This module provides a helper to manage tracing.\nIt is responsible for determining if the tracing should be stopped.\nIt introduces a fuse mechanism to prevent LiveView from being overloaded with traces.","ref":"LiveDebugger.LiveHelpers.TracingHelper.html"},{"type":"function","title":"LiveDebugger.LiveHelpers.TracingHelper.check_fuse/1","doc":"Checks if the fuse is blown and stops tracing if it is.\nIt uses the `tracing_helper` assign to store information.\nWhen tracing is not started returns `{:noop, socket}`.","ref":"LiveDebugger.LiveHelpers.TracingHelper.html#check_fuse/1"},{"type":"function","title":"LiveDebugger.LiveHelpers.TracingHelper.disable_tracing/1","doc":"","ref":"LiveDebugger.LiveHelpers.TracingHelper.html#disable_tracing/1"},{"type":"function","title":"LiveDebugger.LiveHelpers.TracingHelper.init/1","doc":"","ref":"LiveDebugger.LiveHelpers.TracingHelper.html#init/1"},{"type":"function","title":"LiveDebugger.LiveHelpers.TracingHelper.switch_tracing/1","doc":"","ref":"LiveDebugger.LiveHelpers.TracingHelper.html#switch_tracing/1"},{"type":"function","title":"LiveDebugger.LiveHelpers.TracingHelper.time_period/0","doc":"","ref":"LiveDebugger.LiveHelpers.TracingHelper.html#time_period/0"},{"type":"function","title":"LiveDebugger.LiveHelpers.TracingHelper.trace_limit_per_period/0","doc":"","ref":"LiveDebugger.LiveHelpers.TracingHelper.html#trace_limit_per_period/0"},{"type":"module","title":"LiveDebugger.LiveViews.LiveViewsDashboardLive","doc":"It displays all active LiveView sessions in the debugged application.","ref":"LiveDebugger.LiveViews.LiveViewsDashboardLive.html"},{"type":"module","title":"LiveDebugger.LiveViews.SidebarLive","doc":"This live view is responsible for displaying the sidebar of the LiveDebugger.\nIt receives events from the `ChannelDashboardLive` live to open the mobile sidebar.","ref":"LiveDebugger.LiveViews.SidebarLive.html"},{"type":"function","title":"LiveDebugger.LiveViews.SidebarLive.live_render/1","doc":"","ref":"LiveDebugger.LiveViews.SidebarLive.html#live_render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveViews.SidebarLive.live_render/1","doc":"* `socket` (`:map`) (required)\n* `id` (`:string`) (required)\n* `lv_process` (`:map`) (required)\n* `node_id` (`:string`) (required)\n* `url` (`:string`) (required)","ref":"LiveDebugger.LiveViews.SidebarLive.html#live_render/1-attributes"},{"type":"function","title":"LiveDebugger.LiveViews.SidebarLive.render/1","doc":"","ref":"LiveDebugger.LiveViews.SidebarLive.html#render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveViews.SidebarLive.render/1","doc":"* `lv_process` (`:any`) (required)\n* `node_id` (`:any`) (required)\n* `url` (`:any`) (required)","ref":"LiveDebugger.LiveViews.SidebarLive.html#render/1-attributes"},{"type":"module","title":"LiveDebugger.LiveViews.StateLive","doc":"This nested live view displays the state of a LiveView.","ref":"LiveDebugger.LiveViews.StateLive.html"},{"type":"function","title":"LiveDebugger.LiveViews.StateLive.live_render/1","doc":"","ref":"LiveDebugger.LiveViews.StateLive.html#live_render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveViews.StateLive.live_render/1","doc":"* `socket` (`:map`) (required)\n* `id` (`:string`) (required)\n* `lv_process` (`:map`) (required)\n* `node_id` (`:string`) (required)","ref":"LiveDebugger.LiveViews.StateLive.html#live_render/1-attributes"},{"type":"module","title":"LiveDebugger.LiveViews.TracesLive","doc":"This nested live view displays the traces of a LiveView.","ref":"LiveDebugger.LiveViews.TracesLive.html"},{"type":"function","title":"LiveDebugger.LiveViews.TracesLive.live_render/1","doc":"","ref":"LiveDebugger.LiveViews.TracesLive.html#live_render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveViews.TracesLive.live_render/1","doc":"* `socket` (`:map`) (required)\n* `id` (`:string`) (required)\n* `lv_process` (`:map`) (required)\n* `node_id` (`:string`) (required)\n* `root_pid` (`:any`) (required)","ref":"LiveDebugger.LiveViews.TracesLive.html#live_render/1-attributes"},{"type":"function","title":"LiveDebugger.LiveViews.TracesLive.render/1","doc":"","ref":"LiveDebugger.LiveViews.TracesLive.html#render/1"},{"type":"function","title":"Attributes - LiveDebugger.LiveViews.TracesLive.render/1","doc":"* `id` (`:string`) (required)\n* `node_id` (`:map`) (required)\n* `socket_id` (`:string`) (required)","ref":"LiveDebugger.LiveViews.TracesLive.html#render/1-attributes"},{"type":"module","title":"LiveDebugger.Plugs.AllowIframe","doc":"Plug to allow iframes to be embedded in the application.","ref":"LiveDebugger.Plugs.AllowIframe.html"},{"type":"function","title":"LiveDebugger.Plugs.AllowIframe.call/2","doc":"","ref":"LiveDebugger.Plugs.AllowIframe.html#call/2"},{"type":"function","title":"LiveDebugger.Plugs.AllowIframe.init/1","doc":"","ref":"LiveDebugger.Plugs.AllowIframe.html#init/1"},{"type":"module","title":"LiveDebugger.Router","doc":"","ref":"LiveDebugger.Router.html"},{"type":"function","title":"LiveDebugger.Router.call/2","doc":"Callback invoked by Plug on every request.","ref":"LiveDebugger.Router.html#call/2"},{"type":"function","title":"LiveDebugger.Router.dbg_browser/2","doc":"","ref":"LiveDebugger.Router.html#dbg_browser/2"},{"type":"function","title":"LiveDebugger.Router.init/1","doc":"Callback required by Plug that initializes the router\nfor serving web requests.","ref":"LiveDebugger.Router.html#init/1"},{"type":"module","title":"LiveDebugger.Services.ChannelService","doc":"This module provides functions that performs operation on state of LiveView channel.","ref":"LiveDebugger.Services.ChannelService.html"},{"type":"function","title":"LiveDebugger.Services.ChannelService.build_tree/1","doc":"Creates a tree with LiveDebugger.Structs.TreeNode elements from the channel state.","ref":"LiveDebugger.Services.ChannelService.html#build_tree/1"},{"type":"function","title":"LiveDebugger.Services.ChannelService.get_node/2","doc":"Retrieves a TreeNode with the given `id` from the channel state\nThe `id` can be either a PID or a CID.\nReturned node doesn't have children.","ref":"LiveDebugger.Services.ChannelService.html#get_node/2"},{"type":"function","title":"LiveDebugger.Services.ChannelService.node_ids/1","doc":"Returns node ids that are present in the channel state where node can be both LiveView or LiveComponent.\nFor LiveView, the id is the PID of the process. For LiveComponent, the id is the CID.","ref":"LiveDebugger.Services.ChannelService.html#node_ids/1"},{"type":"function","title":"LiveDebugger.Services.ChannelService.state/1","doc":"Retrieves the state of the LiveView channel process identified by `pid`.","ref":"LiveDebugger.Services.ChannelService.html#state/1"},{"type":"module","title":"LiveDebugger.Services.LiveViewDiscoveryService","doc":"This module provides functions that discovers LiveView processes in the debugged application.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.children_lv_processes/2","doc":"Returns all children LvProcesses of the given `pid`.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#children_lv_processes/2"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.debugged_lv_processes/0","doc":"Returns all debugged LvProcesses.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#debugged_lv_processes/0"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.debugger_lv_processes/0","doc":"Returns all LiveDebugger's LvProcesses.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#debugger_lv_processes/0"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.group_lv_processes/1","doc":"Groups LvProcesses by `transport_pid` and `root_pid`. To see map structure see examples.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#group_lv_processes/1"},{"type":"function","title":"Examples - LiveDebugger.Services.LiveViewDiscoveryService.group_lv_processes/1","doc":"iex> lv_processes = LiveDebugger.Services.LiveViewDiscoveryService.debugged_lv_processes()\n    iex> LiveDebugger.Services.LiveViewDiscoveryService.group_lv_processes(lv_processes)\n    %{\n      #<0.123.0> => {\n        %LiveDebugger.Structs.LvProcess{pid: #<0.223.0>} => [\n          %LiveDebugger.Structs.LvProcess{root_pid: #<0.223.0>},\n          %LiveDebugger.Structs.LvProcess{root_pid: #<0.223.0>}\n        ],\n      #<0.124.0> => [\n        %LiveDebugger.Structs.LvProcess{pid: #<0.224.0>} => [\n          %LiveDebugger.Structs.LvProcess{root_pid: #<0.224.0>},\n          %LiveDebugger.Structs.LvProcess{root_pid: #<0.224.0>}\n        ]\n      }\n    }","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#group_lv_processes/1-examples"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.lv_process/2","doc":"Returns LvProcess associated the given `socket_id` and `transport_pid`.\nWhen only `socket_id` is provided, LvProcess with the given `socket_id` is returned.\nWhen more than one process is found, `nil` is returned.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#lv_process/2"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.lv_processes/0","doc":"Returns all LiveView processes.","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#lv_processes/0"},{"type":"function","title":"LiveDebugger.Services.LiveViewDiscoveryService.successor_lv_processes/1","doc":"Finds potential successor LvProcess based on module when websocket connection breaks and new one is created.\nThis is a common scenario when user recompiles code or refreshes the page","ref":"LiveDebugger.Services.LiveViewDiscoveryService.html#successor_lv_processes/1"},{"type":"module","title":"LiveDebugger.Services.ModuleDiscoveryService","doc":"This module provides functions to discover LiveViews and LiveComponents in the current application.","ref":"LiveDebugger.Services.ModuleDiscoveryService.html"},{"type":"function","title":"LiveDebugger.Services.ModuleDiscoveryService.all_modules/0","doc":"","ref":"LiveDebugger.Services.ModuleDiscoveryService.html#all_modules/0"},{"type":"function","title":"LiveDebugger.Services.ModuleDiscoveryService.live_component_modules/1","doc":"Accepts a list of all modules from ModuleService.all/0\nReturns a list of loaded LiveComponent modules.","ref":"LiveDebugger.Services.ModuleDiscoveryService.html#live_component_modules/1"},{"type":"function","title":"Examples - LiveDebugger.Services.ModuleDiscoveryService.live_component_modules/1","doc":"iex> services = LiveDebugger.Services.ModuleService.all()\n[{MyAppWeb.LiveComponent, 'lib/my_app_web/live_component.ex'}, ...]\n\niex> LiveDebugger.Services.ModuleDiscoveryService.live_view_modules(services)\n[MyAppWeb.LiveComponent, ...]","ref":"LiveDebugger.Services.ModuleDiscoveryService.html#live_component_modules/1-examples"},{"type":"function","title":"LiveDebugger.Services.ModuleDiscoveryService.live_view_modules/1","doc":"Accepts a list of all modules from ModuleService.all/0\nReturns a list of loaded LiveView modules.","ref":"LiveDebugger.Services.ModuleDiscoveryService.html#live_view_modules/1"},{"type":"behaviour","title":"LiveDebugger.Services.System.ModuleService","doc":"This module provides wrappers for system functions that queries modules in the current application.","ref":"LiveDebugger.Services.System.ModuleService.html"},{"type":"function","title":"LiveDebugger.Services.System.ModuleService.all/0","doc":"Wrapper for `:code.all_loaded/0` that returns a list of loaded modules.","ref":"LiveDebugger.Services.System.ModuleService.html#all/0"},{"type":"callback","title":"LiveDebugger.Services.System.ModuleService.all/0","doc":"","ref":"LiveDebugger.Services.System.ModuleService.html#c:all/0"},{"type":"function","title":"LiveDebugger.Services.System.ModuleService.behaviours/1","doc":"Returns list of behaviours implemented by the given module.","ref":"LiveDebugger.Services.System.ModuleService.html#behaviours/1"},{"type":"callback","title":"LiveDebugger.Services.System.ModuleService.behaviours/1","doc":"","ref":"LiveDebugger.Services.System.ModuleService.html#c:behaviours/1"},{"type":"function","title":"LiveDebugger.Services.System.ModuleService.loaded?/1","doc":"Wrapper for Code.ensure_loaded?/1 that returns if a module is loaded.","ref":"LiveDebugger.Services.System.ModuleService.html#loaded?/1"},{"type":"callback","title":"LiveDebugger.Services.System.ModuleService.loaded?/1","doc":"","ref":"LiveDebugger.Services.System.ModuleService.html#c:loaded?/1"},{"type":"behaviour","title":"LiveDebugger.Services.System.ProcessService","doc":"This module provides wrappers for system functions that queries processes in the current application.","ref":"LiveDebugger.Services.System.ProcessService.html"},{"type":"function","title":"LiveDebugger.Services.System.ProcessService.initial_call/1","doc":"Wrapper for `Process.info/2` with some additional logic that returns the initial call of the process.","ref":"LiveDebugger.Services.System.ProcessService.html#initial_call/1"},{"type":"callback","title":"LiveDebugger.Services.System.ProcessService.initial_call/1","doc":"","ref":"LiveDebugger.Services.System.ProcessService.html#c:initial_call/1"},{"type":"function","title":"LiveDebugger.Services.System.ProcessService.list/0","doc":"Wrapper for `Process.list/0` that returns a list of pids.","ref":"LiveDebugger.Services.System.ProcessService.html#list/0"},{"type":"callback","title":"LiveDebugger.Services.System.ProcessService.list/0","doc":"","ref":"LiveDebugger.Services.System.ProcessService.html#c:list/0"},{"type":"function","title":"LiveDebugger.Services.System.ProcessService.state/1","doc":"Wrapper for `:sys.get_state/1` with additional error handling that returns the state of the process.","ref":"LiveDebugger.Services.System.ProcessService.html#state/1"},{"type":"callback","title":"LiveDebugger.Services.System.ProcessService.state/1","doc":"","ref":"LiveDebugger.Services.System.ProcessService.html#c:state/1"},{"type":"module","title":"LiveDebugger.Services.TraceService","doc":"This module is responsible for accessing traces from ETS.\nIt uses calls to `CallbackTracingServer` to get proper table reference.","ref":"LiveDebugger.Services.TraceService.html"},{"type":"function","title":"LiveDebugger.Services.TraceService.clear_traces/2","doc":"Deletes traces for LiveView or LiveComponent for given pid.\n\n* `node_id` - PID or CID which identifies node","ref":"LiveDebugger.Services.TraceService.html#clear_traces/2"},{"type":"type","title":"LiveDebugger.Services.TraceService.ets_continuation/0","doc":"","ref":"LiveDebugger.Services.TraceService.html#t:ets_continuation/0"},{"type":"type","title":"LiveDebugger.Services.TraceService.ets_elem/0","doc":"","ref":"LiveDebugger.Services.TraceService.html#t:ets_elem/0"},{"type":"type","title":"LiveDebugger.Services.TraceService.ets_table_id/0","doc":"Pid is used to store mapping to table references.\nIt identifies ETS tables managed by CallbackTracingServer","ref":"LiveDebugger.Services.TraceService.html#t:ets_table_id/0"},{"type":"function","title":"LiveDebugger.Services.TraceService.existing_traces/2","doc":"Returns existing traces of a process for the table with optional filters.","ref":"LiveDebugger.Services.TraceService.html#existing_traces/2"},{"type":"function","title":"Options - LiveDebugger.Services.TraceService.existing_traces/2","doc":"* `:node_id` - PID or CID to filter traces by\n  * `:limit` - Maximum number of traces to return (default: 100)\n  * `:cont` - Used to get next page of items in the following queries\n  * `:functions` - List of function names to filter traces by","ref":"LiveDebugger.Services.TraceService.html#existing_traces/2-options"},{"type":"function","title":"LiveDebugger.Services.TraceService.get/2","doc":"Gets a trace of process from the ETS table by `id`.","ref":"LiveDebugger.Services.TraceService.html#get/2"},{"type":"function","title":"LiveDebugger.Services.TraceService.insert/1","doc":"Inserts a new trace into the ETS table.","ref":"LiveDebugger.Services.TraceService.html#insert/1"},{"type":"function","title":"LiveDebugger.Services.TraceService.to_spec/1","doc":"","ref":"LiveDebugger.Services.TraceService.html#to_spec/1"},{"type":"module","title":"LiveDebugger.Structs.LvProcess","doc":"This module provides a struct to represent a LiveView process.\n\n* nested? - whether the process is a nested LiveView process\n* debugger? - whether the process is a LiveDebugger process","ref":"LiveDebugger.Structs.LvProcess.html"},{"type":"function","title":"LiveDebugger.Structs.LvProcess.new/1","doc":"Creates new LvProcess struct with the given `pid` by fetching the socket from the process state.","ref":"LiveDebugger.Structs.LvProcess.html#new/1"},{"type":"function","title":"LiveDebugger.Structs.LvProcess.new/2","doc":"","ref":"LiveDebugger.Structs.LvProcess.html#new/2"},{"type":"function","title":"LiveDebugger.Structs.LvProcess.parent/1","doc":"Returns the parent LvProcess of the given `lv_process`.","ref":"LiveDebugger.Structs.LvProcess.html#parent/1"},{"type":"type","title":"LiveDebugger.Structs.LvProcess.t/0","doc":"","ref":"LiveDebugger.Structs.LvProcess.html#t:t/0"},{"type":"module","title":"LiveDebugger.Structs.Trace","doc":"This module provides a struct to represent a trace.\n\nID is number generated by :dbg tracer.\nPID is always present.\nCID is optional - it is filled when trace comes from LiveComponent.\n\nWhen trace has PID and CID it means that it comes from LiveComponent.\nWhen trace has only PID it means that it comes from LiveView.\nThere cannot be a trace with CID and without PID.","ref":"LiveDebugger.Structs.Trace.html"},{"type":"function","title":"LiveDebugger.Structs.Trace.callback_name/1","doc":"","ref":"LiveDebugger.Structs.Trace.html#callback_name/1"},{"type":"function","title":"LiveDebugger.Structs.Trace.live_component_delete?/1","doc":"Checks if the trace is a delete live component trace.","ref":"LiveDebugger.Structs.Trace.html#live_component_delete?/1"},{"type":"function","title":"LiveDebugger.Structs.Trace.new/6","doc":"Creates a new trace struct.","ref":"LiveDebugger.Structs.Trace.html#new/6"},{"type":"function","title":"LiveDebugger.Structs.Trace.node_id/1","doc":"Returns the node id from the trace.\nIt is PID if trace comes from a LiveView, CID if trace comes from a LiveComponent.","ref":"LiveDebugger.Structs.Trace.html#node_id/1"},{"type":"type","title":"LiveDebugger.Structs.Trace.t/0","doc":"","ref":"LiveDebugger.Structs.Trace.html#t:t/0"},{"type":"module","title":"LiveDebugger.Structs.TraceDisplay","doc":"This module provides a struct used for displaying traces.\nIt wraps a trace struct and adds additional information.","ref":"LiveDebugger.Structs.TraceDisplay.html"},{"type":"function","title":"LiveDebugger.Structs.TraceDisplay.from_trace/1","doc":"","ref":"LiveDebugger.Structs.TraceDisplay.html#from_trace/1"},{"type":"function","title":"LiveDebugger.Structs.TraceDisplay.render_body/1","doc":"","ref":"LiveDebugger.Structs.TraceDisplay.html#render_body/1"},{"type":"type","title":"LiveDebugger.Structs.TraceDisplay.t/0","doc":"","ref":"LiveDebugger.Structs.TraceDisplay.html#t:t/0"},{"type":"module","title":"LiveDebugger.Structs.TreeNode","doc":"This module provides functions to work with the tree of LiveView and LiveComponent nodes (TreeNodes).","ref":"LiveDebugger.Structs.TreeNode.html"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.add_child/2","doc":"Adds a child to the parent node.","ref":"LiveDebugger.Structs.TreeNode.html#add_child/2"},{"type":"type","title":"LiveDebugger.Structs.TreeNode.cid/0","doc":"","ref":"LiveDebugger.Structs.TreeNode.html#t:cid/0"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.display_id/1","doc":"Returns string representation of the node's ID, ready to be displayed in the UI.","ref":"LiveDebugger.Structs.TreeNode.html#display_id/1"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.get_child/2","doc":"Returns a child of the parent node by PID or CID.","ref":"LiveDebugger.Structs.TreeNode.html#get_child/2"},{"type":"type","title":"LiveDebugger.Structs.TreeNode.id/0","doc":"","ref":"LiveDebugger.Structs.TreeNode.html#t:id/0"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.id/1","doc":"Returns PID or CID of the node.","ref":"LiveDebugger.Structs.TreeNode.html#id/1"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.id_from_string/1","doc":"Parses ID from string to PID or CID.","ref":"LiveDebugger.Structs.TreeNode.html#id_from_string/1"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.id_from_string!/1","doc":"Same as `id_from_string/1`, but raises an ArgumentError if the ID is invalid.","ref":"LiveDebugger.Structs.TreeNode.html#id_from_string!/1"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.live_component_node/2","doc":"Parses channel_state state to LiveDebugger.Structs.TreeNode.LiveComponent of given CID.\nIf the component is not found, returns `nil`.","ref":"LiveDebugger.Structs.TreeNode.html#live_component_node/2"},{"type":"function","title":"Examples - LiveDebugger.Structs.TreeNode.live_component_node/2","doc":"iex> {:ok, state} = LiveDebugger.Services.LiveViewDiscoveryService.channel_state_from_pid(pid)\n    iex> LiveDebugger.Structs.TreeNode.live_component_node(state, 2)\n    {:ok, %LiveDebugger.Structs.TreeNode.LiveComponent{cid: 2, ...}}\n\n    iex> {:ok, state} = LiveDebugger.Services.LiveViewDiscoveryService.channel_state_from_pid(pid)\n    iex> LiveDebugger.Structs.TreeNode.live_component_node(state, 999)\n    {:ok, nil}","ref":"LiveDebugger.Structs.TreeNode.html#live_component_node/2-examples"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.live_component_nodes/1","doc":"Parses channel_state to a list of all LiveDebugger.Structs.TreeNode.LiveComponent nodes.\nIt doesn't include children.","ref":"LiveDebugger.Structs.TreeNode.html#live_component_nodes/1"},{"type":"function","title":"Examples - LiveDebugger.Structs.TreeNode.live_component_nodes/1","doc":"iex> {:ok, state} = LiveDebugger.Services.get_channel_state(pid)\n    iex> LiveDebugger.Structs.TreeNode.live_component_nodes(state)\n    {:ok, [%LiveDebugger.Structs.TreeNode.LiveComponent{...}, ...]}","ref":"LiveDebugger.Structs.TreeNode.html#live_component_nodes/1-examples"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.live_view_node/1","doc":"Parses channel_state to LiveDebugger.Structs.TreeNode.LiveView.","ref":"LiveDebugger.Structs.TreeNode.html#live_view_node/1"},{"type":"function","title":"Examples - LiveDebugger.Structs.TreeNode.live_view_node/1","doc":"iex> {:ok, state} = LiveDebugger.Services.LiveViewDiscoveryService.channel_state_from_pid(pid)\n    iex> LiveDebugger.Structs.TreeNode.live_view_node(state)\n    {:ok, %LiveDebugger.Structs.TreeNode.LiveView{...}}","ref":"LiveDebugger.Structs.TreeNode.html#live_view_node/1-examples"},{"type":"type","title":"LiveDebugger.Structs.TreeNode.t/0","doc":"","ref":"LiveDebugger.Structs.TreeNode.html#t:t/0"},{"type":"function","title":"LiveDebugger.Structs.TreeNode.type/1","doc":"Gives type of the node.\nTypes:\n  * `:live_view`\n  * `:live_component`","ref":"LiveDebugger.Structs.TreeNode.html#type/1"},{"type":"module","title":"LiveDebugger.Structs.TreeNode.LiveComponent","doc":"This module provides a struct to represent a LiveComponent in the tree.","ref":"LiveDebugger.Structs.TreeNode.LiveComponent.html"},{"type":"type","title":"LiveDebugger.Structs.TreeNode.LiveComponent.cid/0","doc":"","ref":"LiveDebugger.Structs.TreeNode.LiveComponent.html#t:cid/0"},{"type":"type","title":"LiveDebugger.Structs.TreeNode.LiveComponent.t/0","doc":"","ref":"LiveDebugger.Structs.TreeNode.LiveComponent.html#t:t/0"},{"type":"module","title":"LiveDebugger.Structs.TreeNode.LiveView","doc":"This module provides a struct to represent a LiveView in the tree.","ref":"LiveDebugger.Structs.TreeNode.LiveView.html"},{"type":"type","title":"LiveDebugger.Structs.TreeNode.LiveView.t/0","doc":"","ref":"LiveDebugger.Structs.TreeNode.LiveView.html#t:t/0"},{"type":"module","title":"LiveDebugger.Utils.Callbacks","doc":"This module provides functions to generate a list of callbacks for LiveViews and LiveComponents.","ref":"LiveDebugger.Utils.Callbacks.html"},{"type":"function","title":"LiveDebugger.Utils.Callbacks.callbacks_functions/0","doc":"Generates a list of all function name callbacks for LiveViews and LiveComponents.","ref":"LiveDebugger.Utils.Callbacks.html#callbacks_functions/0"},{"type":"function","title":"LiveDebugger.Utils.Callbacks.live_component_callbacks/0","doc":"Generates a list of all function name callbacks for LiveComponents.","ref":"LiveDebugger.Utils.Callbacks.html#live_component_callbacks/0"},{"type":"function","title":"LiveDebugger.Utils.Callbacks.live_component_callbacks/1","doc":"Generates a list of callbacks for LiveComponents in form of {module, callback, arity}.\nAccepts a single module or a list of modules.","ref":"LiveDebugger.Utils.Callbacks.html#live_component_callbacks/1"},{"type":"function","title":"LiveDebugger.Utils.Callbacks.live_view_callbacks/0","doc":"Generates a list of all function name callbacks for LiveViews.","ref":"LiveDebugger.Utils.Callbacks.html#live_view_callbacks/0"},{"type":"function","title":"LiveDebugger.Utils.Callbacks.live_view_callbacks/1","doc":"Generates a list of callbacks for LiveViews in form of {module, callback, arity}.\nAccept a single module or a list of modules.","ref":"LiveDebugger.Utils.Callbacks.html#live_view_callbacks/1"},{"type":"module","title":"LiveDebugger.Utils.Parsers","doc":"This module provides functions to parse some structs to string representation and vice versa.","ref":"LiveDebugger.Utils.Parsers.html"},{"type":"function","title":"LiveDebugger.Utils.Parsers.cid_to_string/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#cid_to_string/1"},{"type":"function","title":"LiveDebugger.Utils.Parsers.module_to_string/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#module_to_string/1"},{"type":"function","title":"LiveDebugger.Utils.Parsers.parse_elapsed_time/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#parse_elapsed_time/1"},{"type":"function","title":"LiveDebugger.Utils.Parsers.parse_timestamp/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#parse_timestamp/1"},{"type":"function","title":"LiveDebugger.Utils.Parsers.pid_to_string/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#pid_to_string/1"},{"type":"function","title":"LiveDebugger.Utils.Parsers.string_to_cid/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#string_to_cid/1"},{"type":"function","title":"LiveDebugger.Utils.Parsers.string_to_pid/1","doc":"","ref":"LiveDebugger.Utils.Parsers.html#string_to_pid/1"},{"type":"module","title":"LiveDebugger.Utils.PubSub","doc":"This module provides helpers for LiveDebugger's PubSub.","ref":"LiveDebugger.Utils.PubSub.html"},{"type":"function","title":"LiveDebugger.Utils.PubSub.broadcast/2","doc":"","ref":"LiveDebugger.Utils.PubSub.html#broadcast/2"},{"type":"function","title":"LiveDebugger.Utils.PubSub.component_deleted_topic/1","doc":"","ref":"LiveDebugger.Utils.PubSub.html#component_deleted_topic/1"},{"type":"function","title":"LiveDebugger.Utils.PubSub.component_deleted_topic/2","doc":"","ref":"LiveDebugger.Utils.PubSub.html#component_deleted_topic/2"},{"type":"function","title":"LiveDebugger.Utils.PubSub.node_changed_topic/1","doc":"","ref":"LiveDebugger.Utils.PubSub.html#node_changed_topic/1"},{"type":"function","title":"LiveDebugger.Utils.PubSub.process_status_topic/1","doc":"","ref":"LiveDebugger.Utils.PubSub.html#process_status_topic/1"},{"type":"function","title":"LiveDebugger.Utils.PubSub.subscribe!/1","doc":"","ref":"LiveDebugger.Utils.PubSub.html#subscribe!/1"},{"type":"function","title":"LiveDebugger.Utils.PubSub.ts_f_topic/3","doc":"It stands for transport_pid/socket_id/*/function.\n\nIt gives you traces of given callback in all nodes of given LiveView\nUsed for detecting new nodes in sidebar","ref":"LiveDebugger.Utils.PubSub.html#ts_f_topic/3"},{"type":"function","title":"LiveDebugger.Utils.PubSub.tsnf_topic/4","doc":"It stands for transport_pid/socket_id/node_id/function.\n\nIt gives you traces of given callback in given node in given LiveView\nUsed to update assigns based on render callback and for filtering traces","ref":"LiveDebugger.Utils.PubSub.html#tsnf_topic/4"},{"type":"function","title":"LiveDebugger.Utils.PubSub.unsubscribe/1","doc":"","ref":"LiveDebugger.Utils.PubSub.html#unsubscribe/1"},{"type":"module","title":"LiveDebugger.Utils.TermParser","doc":"This module provides functions to parse terms into display tree.\nBased on [Kino.Tree](https://github.com/livebook-dev/kino/blob/main/lib/kino/tree.ex)","ref":"LiveDebugger.Utils.TermParser.html"},{"type":"type","title":"LiveDebugger.Utils.TermParser.display_element/0","doc":"","ref":"LiveDebugger.Utils.TermParser.html#t:display_element/0"},{"type":"function","title":"LiveDebugger.Utils.TermParser.term_to_display_tree/1","doc":"","ref":"LiveDebugger.Utils.TermParser.html#term_to_display_tree/1"},{"type":"type","title":"LiveDebugger.Utils.TermParser.tree_element/0","doc":"","ref":"LiveDebugger.Utils.TermParser.html#t:tree_element/0"},{"type":"module","title":"LiveDebugger.Utils.URL","doc":"URL utilities for managing URLs and query params.","ref":"LiveDebugger.Utils.URL.html"},{"type":"function","title":"LiveDebugger.Utils.URL.modify_query_params/2","doc":"","ref":"LiveDebugger.Utils.URL.html#modify_query_params/2"},{"type":"function","title":"LiveDebugger.Utils.URL.remove_query_param/2","doc":"","ref":"LiveDebugger.Utils.URL.html#remove_query_param/2"},{"type":"function","title":"LiveDebugger.Utils.URL.remove_query_params/2","doc":"","ref":"LiveDebugger.Utils.URL.html#remove_query_params/2"},{"type":"function","title":"LiveDebugger.Utils.URL.to_relative/1","doc":"Converts an absolute URL to a relative URL.","ref":"LiveDebugger.Utils.URL.html#to_relative/1"},{"type":"function","title":"Examples - LiveDebugger.Utils.URL.to_relative/1","doc":"iex> URL.to_relative(\"http://example.com/foo?bar=baz\")\n    \"/foo?bar=baz\"","ref":"LiveDebugger.Utils.URL.html#to_relative/1-examples"},{"type":"function","title":"LiveDebugger.Utils.URL.update_path/2","doc":"","ref":"LiveDebugger.Utils.URL.html#update_path/2"},{"type":"function","title":"LiveDebugger.Utils.URL.upsert_query_param/3","doc":"","ref":"LiveDebugger.Utils.URL.html#upsert_query_param/3"},{"type":"function","title":"LiveDebugger.Utils.URL.upsert_query_params/2","doc":"","ref":"LiveDebugger.Utils.URL.html#upsert_query_params/2"},{"type":"module","title":"LiveDebuggerDev.Components","doc":"","ref":"LiveDebuggerDev.Components.html"},{"type":"function","title":"LiveDebuggerDev.Components.box/1","doc":"","ref":"LiveDebuggerDev.Components.html#box/1"},{"type":"function","title":"Attributes - LiveDebuggerDev.Components.box/1","doc":"* `title` (`:string`) (required)\n* `color` (`:string`) - Defaults to `\"blue\"`.\n* `class` (`:string`) - Defaults to `\"\"`.","ref":"LiveDebuggerDev.Components.html#box/1-attributes"},{"type":"function","title":"Slots - LiveDebuggerDev.Components.box/1","doc":"* `inner_block` (required)","ref":"LiveDebuggerDev.Components.html#box/1-slots"},{"type":"function","title":"LiveDebuggerDev.Components.button/1","doc":"","ref":"LiveDebuggerDev.Components.html#button/1"},{"type":"function","title":"Attributes - LiveDebuggerDev.Components.button/1","doc":"* `color` (`:string`) - Defaults to `\"green\"`.\n* Global attributes are accepted.","ref":"LiveDebuggerDev.Components.html#button/1-attributes"},{"type":"function","title":"Slots - LiveDebuggerDev.Components.button/1","doc":"* `inner_block` (required)","ref":"LiveDebuggerDev.Components.html#button/1-slots"},{"type":"function","title":"LiveDebuggerDev.Components.navbar/1","doc":"","ref":"LiveDebuggerDev.Components.html#navbar/1"},{"type":"function","title":"Attributes - LiveDebuggerDev.Components.navbar/1","doc":"* `routes` (`:list`) - Defaults to `[{\"/\", \"Main\"}, {\"/side\", \"Side\"}, {\"/nested\", \"Nested\"}, {\"/messages\", \"Messages\"}, {\"/embedded\", \"Embedded\"}, {\"/embedded_in_controller\", \"EmbeddedInController\"}]`.","ref":"LiveDebuggerDev.Components.html#navbar/1-attributes"},{"type":"module","title":"LiveDebuggerDev.EmbeddedLiveViewController","doc":"","ref":"LiveDebuggerDev.EmbeddedLiveViewController.html"},{"type":"function","title":"LiveDebuggerDev.EmbeddedLiveViewController.embedded/2","doc":"","ref":"LiveDebuggerDev.EmbeddedLiveViewController.html#embedded/2"},{"type":"module","title":"LiveDebuggerDev.Endpoint","doc":"","ref":"LiveDebuggerDev.Endpoint.html"},{"type":"function","title":"LiveDebuggerDev.Endpoint.broadcast/3","doc":"","ref":"LiveDebuggerDev.Endpoint.html#broadcast/3"},{"type":"function","title":"LiveDebuggerDev.Endpoint.broadcast!/3","doc":"","ref":"LiveDebuggerDev.Endpoint.html#broadcast!/3"},{"type":"function","title":"LiveDebuggerDev.Endpoint.broadcast_from/4","doc":"","ref":"LiveDebuggerDev.Endpoint.html#broadcast_from/4"},{"type":"function","title":"LiveDebuggerDev.Endpoint.broadcast_from!/4","doc":"","ref":"LiveDebuggerDev.Endpoint.html#broadcast_from!/4"},{"type":"function","title":"LiveDebuggerDev.Endpoint.call/2","doc":"","ref":"LiveDebuggerDev.Endpoint.html#call/2"},{"type":"function","title":"LiveDebuggerDev.Endpoint.child_spec/1","doc":"Returns the child specification to start the endpoint\nunder a supervision tree.","ref":"LiveDebuggerDev.Endpoint.html#child_spec/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.config/2","doc":"Returns the endpoint configuration for `key`\n\nReturns `default` if the key does not exist.","ref":"LiveDebuggerDev.Endpoint.html#config/2"},{"type":"function","title":"LiveDebuggerDev.Endpoint.config_change/2","doc":"Reloads the configuration given the application environment changes.","ref":"LiveDebuggerDev.Endpoint.html#config_change/2"},{"type":"function","title":"LiveDebuggerDev.Endpoint.host/0","doc":"Returns the host for the given endpoint.","ref":"LiveDebuggerDev.Endpoint.html#host/0"},{"type":"function","title":"LiveDebuggerDev.Endpoint.init/1","doc":"","ref":"LiveDebuggerDev.Endpoint.html#init/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.local_broadcast/3","doc":"","ref":"LiveDebuggerDev.Endpoint.html#local_broadcast/3"},{"type":"function","title":"LiveDebuggerDev.Endpoint.local_broadcast_from/4","doc":"","ref":"LiveDebuggerDev.Endpoint.html#local_broadcast_from/4"},{"type":"function","title":"LiveDebuggerDev.Endpoint.path/1","doc":"Generates the path information when routing to this endpoint.","ref":"LiveDebuggerDev.Endpoint.html#path/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.script_name/0","doc":"Generates the script name.","ref":"LiveDebuggerDev.Endpoint.html#script_name/0"},{"type":"function","title":"LiveDebuggerDev.Endpoint.server_info/1","doc":"Returns the address and port that the server is running on","ref":"LiveDebuggerDev.Endpoint.html#server_info/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.start_link/1","doc":"Starts the endpoint supervision tree.\n\nAll other options are merged into the endpoint configuration.","ref":"LiveDebuggerDev.Endpoint.html#start_link/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.static_integrity/1","doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file\nin `priv/static`. Meant to be used for Subresource Integrity with CDNs.","ref":"LiveDebuggerDev.Endpoint.html#static_integrity/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.static_lookup/1","doc":"Returns a two item tuple with the first item being the `static_path`\nand the second item being the `static_integrity`.","ref":"LiveDebuggerDev.Endpoint.html#static_lookup/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.static_path/1","doc":"Generates a route to a static file in `priv/static`.","ref":"LiveDebuggerDev.Endpoint.html#static_path/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.static_url/0","doc":"Generates the static URL without any path information.\n\nIt uses the configuration under `:static_url` to generate\nsuch. It falls back to `:url` if `:static_url` is not set.","ref":"LiveDebuggerDev.Endpoint.html#static_url/0"},{"type":"function","title":"LiveDebuggerDev.Endpoint.struct_url/0","doc":"Generates the endpoint base URL but as a `URI` struct.\n\nIt uses the configuration under `:url` to generate such.\nUseful for manipulating the URL data and passing it to\nURL helpers.","ref":"LiveDebuggerDev.Endpoint.html#struct_url/0"},{"type":"function","title":"LiveDebuggerDev.Endpoint.subscribe/2","doc":"","ref":"LiveDebuggerDev.Endpoint.html#subscribe/2"},{"type":"function","title":"LiveDebuggerDev.Endpoint.unsubscribe/1","doc":"","ref":"LiveDebuggerDev.Endpoint.html#unsubscribe/1"},{"type":"function","title":"LiveDebuggerDev.Endpoint.url/0","doc":"Generates the endpoint base URL without any path information.\n\nIt uses the configuration under `:url` to generate such.","ref":"LiveDebuggerDev.Endpoint.html#url/0"},{"type":"module","title":"LiveDebuggerDev.Layout","doc":"","ref":"LiveDebuggerDev.Layout.html"},{"type":"module","title":"LiveDebuggerDev.LiveComponents.Conditional","doc":"","ref":"LiveDebuggerDev.LiveComponents.Conditional.html"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Conditional.handle_event/3","doc":"","ref":"LiveDebuggerDev.LiveComponents.Conditional.html#handle_event/3"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Conditional.mount/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.Conditional.html#mount/1"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Conditional.render/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.Conditional.html#render/1"},{"type":"function","title":"Slots - LiveDebuggerDev.LiveComponents.Conditional.render/1","doc":"* `inner_block`","ref":"LiveDebuggerDev.LiveComponents.Conditional.html#render/1-slots"},{"type":"module","title":"LiveDebuggerDev.LiveComponents.LiveComponentWithVeryVeryLongName","doc":"","ref":"LiveDebuggerDev.LiveComponents.LiveComponentWithVeryVeryLongName.html"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.LiveComponentWithVeryVeryLongName.render/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.LiveComponentWithVeryVeryLongName.html#render/1"},{"type":"module","title":"LiveDebuggerDev.LiveComponents.ManyAssigns","doc":"","ref":"LiveDebuggerDev.LiveComponents.ManyAssigns.html"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.ManyAssigns.render/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.ManyAssigns.html#render/1"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.ManyAssigns.update/2","doc":"","ref":"LiveDebuggerDev.LiveComponents.ManyAssigns.html#update/2"},{"type":"module","title":"LiveDebuggerDev.LiveComponents.Name","doc":"","ref":"LiveDebuggerDev.LiveComponents.Name.html"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Name.render/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.Name.html#render/1"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Name.update/2","doc":"","ref":"LiveDebuggerDev.LiveComponents.Name.html#update/2"},{"type":"module","title":"LiveDebuggerDev.LiveComponents.Recursive","doc":"","ref":"LiveDebuggerDev.LiveComponents.Recursive.html"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Recursive.render/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.Recursive.html#render/1"},{"type":"function","title":"Attributes - LiveDebuggerDev.LiveComponents.Recursive.render/1","doc":"* `id` (`:string`) (required)\n* `counter` (`:integer`) (required)","ref":"LiveDebuggerDev.LiveComponents.Recursive.html#render/1-attributes"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Recursive.update/2","doc":"","ref":"LiveDebuggerDev.LiveComponents.Recursive.html#update/2"},{"type":"module","title":"LiveDebuggerDev.LiveComponents.Send","doc":"","ref":"LiveDebuggerDev.LiveComponents.Send.html"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Send.handle_event/3","doc":"","ref":"LiveDebuggerDev.LiveComponents.Send.html#handle_event/3"},{"type":"function","title":"LiveDebuggerDev.LiveComponents.Send.render/1","doc":"","ref":"LiveDebuggerDev.LiveComponents.Send.html#render/1"},{"type":"function","title":"Slots - LiveDebuggerDev.LiveComponents.Send.render/1","doc":"* `inner_block`","ref":"LiveDebuggerDev.LiveComponents.Send.html#render/1-slots"},{"type":"module","title":"LiveDebuggerDev.LiveViews.Embedded","doc":"","ref":"LiveDebuggerDev.LiveViews.Embedded.html"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Embedded.render/1","doc":"","ref":"LiveDebuggerDev.LiveViews.Embedded.html#render/1"},{"type":"module","title":"LiveDebuggerDev.LiveViews.Main","doc":"","ref":"LiveDebuggerDev.LiveViews.Main.html"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Main.handle_event/3","doc":"","ref":"LiveDebuggerDev.LiveViews.Main.html#handle_event/3"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Main.handle_info/2","doc":"","ref":"LiveDebuggerDev.LiveViews.Main.html#handle_info/2"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Main.mount/3","doc":"","ref":"LiveDebuggerDev.LiveViews.Main.html#mount/3"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Main.render/1","doc":"","ref":"LiveDebuggerDev.LiveViews.Main.html#render/1"},{"type":"module","title":"LiveDebuggerDev.LiveViews.Messages","doc":"","ref":"LiveDebuggerDev.LiveViews.Messages.html"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Messages.handle_event/3","doc":"","ref":"LiveDebuggerDev.LiveViews.Messages.html#handle_event/3"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Messages.handle_info/2","doc":"","ref":"LiveDebuggerDev.LiveViews.Messages.html#handle_info/2"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Messages.render/1","doc":"","ref":"LiveDebuggerDev.LiveViews.Messages.html#render/1"},{"type":"module","title":"LiveDebuggerDev.LiveViews.Nested","doc":"","ref":"LiveDebuggerDev.LiveViews.Nested.html"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Nested.render/1","doc":"","ref":"LiveDebuggerDev.LiveViews.Nested.html#render/1"},{"type":"module","title":"LiveDebuggerDev.LiveViews.Side","doc":"","ref":"LiveDebuggerDev.LiveViews.Side.html"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Side.handle_info/2","doc":"","ref":"LiveDebuggerDev.LiveViews.Side.html#handle_info/2"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Side.mount/3","doc":"","ref":"LiveDebuggerDev.LiveViews.Side.html#mount/3"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Side.render/1","doc":"","ref":"LiveDebuggerDev.LiveViews.Side.html#render/1"},{"type":"module","title":"LiveDebuggerDev.LiveViews.Simple","doc":"","ref":"LiveDebuggerDev.LiveViews.Simple.html"},{"type":"function","title":"LiveDebuggerDev.LiveViews.Simple.render/1","doc":"","ref":"LiveDebuggerDev.LiveViews.Simple.html#render/1"},{"type":"module","title":"LiveDebuggerDev.Router","doc":"","ref":"LiveDebuggerDev.Router.html"},{"type":"function","title":"LiveDebuggerDev.Router.browser/2","doc":"","ref":"LiveDebuggerDev.Router.html#browser/2"},{"type":"function","title":"LiveDebuggerDev.Router.call/2","doc":"Callback invoked by Plug on every request.","ref":"LiveDebuggerDev.Router.html#call/2"},{"type":"function","title":"LiveDebuggerDev.Router.init/1","doc":"Callback required by Plug that initializes the router\nfor serving web requests.","ref":"LiveDebuggerDev.Router.html#init/1"},{"type":"module","title":"LiveDebuggerDev.Runner","doc":"","ref":"LiveDebuggerDev.Runner.html"},{"type":"function","title":"LiveDebuggerDev.Runner.run/0","doc":"","ref":"LiveDebuggerDev.Runner.html#run/0"},{"type":"task","title":"mix live_debugger.install","doc":"Installs live_debugger. Use `mix igniter.install live_debugger` to call. Requires igniter to run.","ref":"Mix.Tasks.LiveDebugger.Install.html"},{"type":"task","title":"Example - mix live_debugger.install","doc":"```bash\nmix igniter.install live_debugger\n```","ref":"Mix.Tasks.LiveDebugger.Install.html#module-example"},{"type":"extras","title":"LiveDebugger","doc":"# LiveDebugger\n\nLiveDebugger is a browser-based tool for debugging applications written in [Phoenix LiveView](https://github.com/phoenixframework/phoenix_live_view) - an Elixir library designed for building rich, interactive online experiences with server-rendered HTML.\n\nDesigned to enhance your development experience LiveDebugger gives you:\n\n- :deciduous_tree: A detailed view of your LiveComponents tree\n- :mag: The ability to inspect assigns for LiveViews and LiveComponents\n- :link: Tracing of their callback executions\n\nhttps://github.com/user-attachments/assets/37f1219c-93cc-4d06-96f7-9b2140a1c971","ref":"readme.html"},{"type":"extras","title":"Installation - LiveDebugger","doc":"Add `live_debugger` to your list of dependencies in `mix.exs`:\n\n```elixir\n  defp deps do\n    [\n      {:live_debugger, \"~> 0.1.5\", only: :dev}\n    ]\n  end\n```\n\nFor full experience we recommend adding below line to your application root layout. It attaches `meta` tag and LiveDebugger scripts in dev environment enabling browser features.\n\n```elixir\n  # lib/my_app_web/components/layouts/root.html.heex\n\n   \n    <%= Application.get_env(:live_debugger, :live_debugger_tags) %>\n   \n```\n\nAfter you start your application LiveDebugger will be running at a default port `http://localhost:4007`.\n\n> [!WARNING]  \n> LiveDebugger should not be used on production! Make sure that the dependency you've added is `:dev` only","ref":"readme.html#installation"},{"type":"extras","title":"Browser features - LiveDebugger","doc":"List of browser features:\n\n- Debug button\n- Components highlighting (coming soon!)\n\nSome features require injecting JS into the debugged application. You can disable them in your config.\n\n```elixir\n# config/dev.exs\n\n# Disables all browser features and does not inject LiveDebugger JS\nconfig :live_debugger, browser_features?: false\n\n# Disables only debug button\nconfig :live_debugger, debug_button?: false\n```","ref":"readme.html#browser-features"},{"type":"extras","title":"Content Security Policy - LiveDebugger","doc":"In `router.ex` of your Phoenix app, make sure your locally running Phoenix app can access the LiveDebugger JS files on port 4007. To achieve that you may need to extend your CSP in `:dev` mode:\n\n```elixir\n  @csp \"{...your CSP} #{if Mix.env() == :dev, do: \"http://127.0.0.1:4007\"}\"\n\n  pipeline :browser do\n    # ...\n    plug :put_secure_browser_headers, %{\"content-security-policy\" => @csp}\n```","ref":"readme.html#content-security-policy"},{"type":"extras","title":"Igniter - LiveDebugger","doc":"LiveDebugger has [Igniter](https://github.com/ash-project/igniter) support - an alternative for standard mix installation. It'll automatically add LiveDebugger dependency and modify your `root.html.heex` after you use the below command.\n\n```bash\nmix igniter.install live_debugger\n```\n\nMake sure that added dependency is `:dev` only.","ref":"readme.html#igniter"},{"type":"extras","title":"Optional configuration - LiveDebugger","doc":"```elixir\n# config/dev.exs\n\nconfig :live_debugger,\n  ip: {127, 0, 0, 1}, # IP on which LiveDebugger will be hosted\n  port: 4007, # Port on which LiveDebugger will be hosted\n  secret_key_base:  , # Secret key used for LiveDebugger.Endpoint\n  signing_salt: \"your_signing_salt\", # Signing salt used for LiveDebugger.Endpoint\n  adapter: Bandit.PhoenixAdapter # Adapter used in LiveDebugger.Endpoint\n  tracing_setup_delay: 0 # Time in ms after tracing will be initialized. Useful in case multi-nodes envs\n```","ref":"readme.html#optional-configuration"},{"type":"extras","title":"Contributing - LiveDebugger","doc":"For those planning to contribute to this project, you can run a dev version of the debugger with the following commands:\n\n```console\nmix setup\niex -S mix\n```\n\nIt'll run the application declared in the `dev/` directory with the library installed.\n\nLiveReload is working both for `.ex` files and static files, but if some styles don't show up, try using this command\n\n```console\nmix assets.build:dev\n```","ref":"readme.html#contributing"},{"type":"extras","title":"Authors - LiveDebugger","doc":"LiveDebugger is created by Software Mansion.\n\nSince 2012 [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=livedebugger) is a software agency with experience in building web and mobile apps as well as complex multimedia solutions. We are Core React Native Contributors, Elixir ecosystem experts, and live streaming and broadcasting technologies specialists. We can help you build your next dream product – [Hire us](https://swmansion.com/contact/projects).\n\nCopyright 2025, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=livedebugger)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=livedebugger-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=livedebugger)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#authors"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2025 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}